]> asedeno.scripts.mit.edu Git - git.git/blob - t/test-lib.sh
diff: handle lines containing only whitespace and tabs better
[git.git] / t / test-lib.sh
1 #!/bin/sh
2 #
3 # Copyright (c) 2005 Junio C Hamano
4 #
5 # This program is free software: you can redistribute it and/or modify
6 # it under the terms of the GNU General Public License as published by
7 # the Free Software Foundation, either version 2 of the License, or
8 # (at your option) any later version.
9 #
10 # This program is distributed in the hope that it will be useful,
11 # but WITHOUT ANY WARRANTY; without even the implied warranty of
12 # MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
13 # GNU General Public License for more details.
14 #
15 # You should have received a copy of the GNU General Public License
16 # along with this program.  If not, see http://www.gnu.org/licenses/ .
17
18 # if --tee was passed, write the output not only to the terminal, but
19 # additionally to the file test-results/$BASENAME.out, too.
20 case "$GIT_TEST_TEE_STARTED, $* " in
21 done,*)
22         # do not redirect again
23         ;;
24 *' --tee '*|*' --va'*)
25         mkdir -p test-results
26         BASE=test-results/$(basename "$0" .sh)
27         (GIT_TEST_TEE_STARTED=done ${SHELL-sh} "$0" "$@" 2>&1;
28          echo $? > $BASE.exit) | tee $BASE.out
29         test "$(cat $BASE.exit)" = 0
30         exit
31         ;;
32 esac
33
34 # Keep the original TERM for say_color
35 ORIGINAL_TERM=$TERM
36
37 # For repeatability, reset the environment to known value.
38 LANG=C
39 LC_ALL=C
40 PAGER=cat
41 TZ=UTC
42 TERM=dumb
43 export LANG LC_ALL PAGER TERM TZ
44 EDITOR=:
45 unset VISUAL
46 unset GIT_EDITOR
47 unset AUTHOR_DATE
48 unset AUTHOR_EMAIL
49 unset AUTHOR_NAME
50 unset COMMIT_AUTHOR_EMAIL
51 unset COMMIT_AUTHOR_NAME
52 unset EMAIL
53 unset GIT_ALTERNATE_OBJECT_DIRECTORIES
54 unset GIT_AUTHOR_DATE
55 GIT_AUTHOR_EMAIL=author@example.com
56 GIT_AUTHOR_NAME='A U Thor'
57 unset GIT_COMMITTER_DATE
58 GIT_COMMITTER_EMAIL=committer@example.com
59 GIT_COMMITTER_NAME='C O Mitter'
60 unset GIT_DIFF_OPTS
61 unset GIT_DIR
62 unset GIT_WORK_TREE
63 unset GIT_EXTERNAL_DIFF
64 unset GIT_INDEX_FILE
65 unset GIT_OBJECT_DIRECTORY
66 unset GIT_CEILING_DIRECTORIES
67 unset SHA1_FILE_DIRECTORIES
68 unset SHA1_FILE_DIRECTORY
69 unset GIT_NOTES_REF
70 unset GIT_NOTES_DISPLAY_REF
71 unset GIT_NOTES_REWRITE_REF
72 unset GIT_NOTES_REWRITE_MODE
73 GIT_MERGE_VERBOSITY=5
74 export GIT_MERGE_VERBOSITY
75 export GIT_AUTHOR_EMAIL GIT_AUTHOR_NAME
76 export GIT_COMMITTER_EMAIL GIT_COMMITTER_NAME
77 export EDITOR
78
79 # Protect ourselves from common misconfiguration to export
80 # CDPATH into the environment
81 unset CDPATH
82
83 unset GREP_OPTIONS
84
85 case $(echo $GIT_TRACE |tr "[A-Z]" "[a-z]") in
86         1|2|true)
87                 echo "* warning: Some tests will not work if GIT_TRACE" \
88                         "is set as to trace on STDERR ! *"
89                 echo "* warning: Please set GIT_TRACE to something" \
90                         "other than 1, 2 or true ! *"
91                 ;;
92 esac
93
94 # Convenience
95 #
96 # A regexp to match 5 and 40 hexdigits
97 _x05='[0-9a-f][0-9a-f][0-9a-f][0-9a-f][0-9a-f]'
98 _x40="$_x05$_x05$_x05$_x05$_x05$_x05$_x05$_x05"
99
100 # Each test should start with something like this, after copyright notices:
101 #
102 # test_description='Description of this test...
103 # This test checks if command xyzzy does the right thing...
104 # '
105 # . ./test-lib.sh
106 [ "x$ORIGINAL_TERM" != "xdumb" ] && (
107                 TERM=$ORIGINAL_TERM &&
108                 export TERM &&
109                 [ -t 1 ] &&
110                 tput bold >/dev/null 2>&1 &&
111                 tput setaf 1 >/dev/null 2>&1 &&
112                 tput sgr0 >/dev/null 2>&1
113         ) &&
114         color=t
115
116 while test "$#" -ne 0
117 do
118         case "$1" in
119         -d|--d|--de|--deb|--debu|--debug)
120                 debug=t; shift ;;
121         -i|--i|--im|--imm|--imme|--immed|--immedi|--immedia|--immediat|--immediate)
122                 immediate=t; shift ;;
123         -l|--l|--lo|--lon|--long|--long-|--long-t|--long-te|--long-tes|--long-test|--long-tests)
124                 GIT_TEST_LONG=t; export GIT_TEST_LONG; shift ;;
125         -h|--h|--he|--hel|--help)
126                 help=t; shift ;;
127         -v|--v|--ve|--ver|--verb|--verbo|--verbos|--verbose)
128                 verbose=t; shift ;;
129         -q|--q|--qu|--qui|--quie|--quiet)
130                 # Ignore --quiet under a TAP::Harness. Saying how many tests
131                 # passed without the ok/not ok details is always an error.
132                 test -z "$HARNESS_ACTIVE" && quiet=t; shift ;;
133         --with-dashes)
134                 with_dashes=t; shift ;;
135         --no-color)
136                 color=; shift ;;
137         --va|--val|--valg|--valgr|--valgri|--valgrin|--valgrind)
138                 valgrind=t; verbose=t; shift ;;
139         --tee)
140                 shift ;; # was handled already
141         --root=*)
142                 root=$(expr "z$1" : 'z[^=]*=\(.*\)')
143                 shift ;;
144         *)
145                 echo "error: unknown test option '$1'" >&2; exit 1 ;;
146         esac
147 done
148
149 if test -n "$color"; then
150         say_color () {
151                 (
152                 TERM=$ORIGINAL_TERM
153                 export TERM
154                 case "$1" in
155                         error) tput bold; tput setaf 1;; # bold red
156                         skip)  tput bold; tput setaf 2;; # bold green
157                         pass)  tput setaf 2;;            # green
158                         info)  tput setaf 3;;            # brown
159                         *) test -n "$quiet" && return;;
160                 esac
161                 shift
162                 printf "%s" "$*"
163                 tput sgr0
164                 echo
165                 )
166         }
167 else
168         say_color() {
169                 test -z "$1" && test -n "$quiet" && return
170                 shift
171                 echo "$*"
172         }
173 fi
174
175 error () {
176         say_color error "error: $*"
177         GIT_EXIT_OK=t
178         exit 1
179 }
180
181 say () {
182         say_color info "$*"
183 }
184
185 test "${test_description}" != "" ||
186 error "Test script did not set test_description."
187
188 if test "$help" = "t"
189 then
190         echo "$test_description"
191         exit 0
192 fi
193
194 exec 5>&1
195 if test "$verbose" = "t"
196 then
197         exec 4>&2 3>&1
198 else
199         exec 4>/dev/null 3>/dev/null
200 fi
201
202 test_failure=0
203 test_count=0
204 test_fixed=0
205 test_broken=0
206 test_success=0
207
208 test_external_has_tap=0
209
210 die () {
211         code=$?
212         if test -n "$GIT_EXIT_OK"
213         then
214                 exit $code
215         else
216                 echo >&5 "FATAL: Unexpected exit with code $code"
217                 exit 1
218         fi
219 }
220
221 GIT_EXIT_OK=
222 trap 'die' EXIT
223
224 # The semantics of the editor variables are that of invoking
225 # sh -c "$EDITOR \"$@\"" files ...
226 #
227 # If our trash directory contains shell metacharacters, they will be
228 # interpreted if we just set $EDITOR directly, so do a little dance with
229 # environment variables to work around this.
230 #
231 # In particular, quoting isn't enough, as the path may contain the same quote
232 # that we're using.
233 test_set_editor () {
234         FAKE_EDITOR="$1"
235         export FAKE_EDITOR
236         EDITOR='"$FAKE_EDITOR"'
237         export EDITOR
238 }
239
240 test_decode_color () {
241         awk '
242                 function name(n) {
243                         if (n == 0) return "RESET";
244                         if (n == 1) return "BOLD";
245                         if (n == 30) return "BLACK";
246                         if (n == 31) return "RED";
247                         if (n == 32) return "GREEN";
248                         if (n == 33) return "YELLOW";
249                         if (n == 34) return "BLUE";
250                         if (n == 35) return "MAGENTA";
251                         if (n == 36) return "CYAN";
252                         if (n == 37) return "WHITE";
253                         if (n == 40) return "BLACK";
254                         if (n == 41) return "BRED";
255                         if (n == 42) return "BGREEN";
256                         if (n == 43) return "BYELLOW";
257                         if (n == 44) return "BBLUE";
258                         if (n == 45) return "BMAGENTA";
259                         if (n == 46) return "BCYAN";
260                         if (n == 47) return "BWHITE";
261                 }
262                 {
263                         while (match($0, /\x1b\[[0-9;]*m/) != 0) {
264                                 printf "%s<", substr($0, 1, RSTART-1);
265                                 codes = substr($0, RSTART+2, RLENGTH-3);
266                                 if (length(codes) == 0)
267                                         printf "%s", name(0)
268                                 else {
269                                         n = split(codes, ary, ";");
270                                         sep = "";
271                                         for (i = 1; i <= n; i++) {
272                                                 printf "%s%s", sep, name(ary[i]);
273                                                 sep = ";"
274                                         }
275                                 }
276                                 printf ">";
277                                 $0 = substr($0, RSTART + RLENGTH, length($0) - RSTART - RLENGTH + 1);
278                         }
279                         print
280                 }
281         '
282 }
283
284 q_to_nul () {
285         perl -pe 'y/Q/\000/'
286 }
287
288 q_to_cr () {
289         tr Q '\015'
290 }
291
292 q_to_tab () {
293         tr Q '\011'
294 }
295
296 append_cr () {
297         sed -e 's/$/Q/' | tr Q '\015'
298 }
299
300 remove_cr () {
301         tr '\015' Q | sed -e 's/Q$//'
302 }
303
304 test_tick () {
305         if test -z "${test_tick+set}"
306         then
307                 test_tick=1112911993
308         else
309                 test_tick=$(($test_tick + 60))
310         fi
311         GIT_COMMITTER_DATE="$test_tick -0700"
312         GIT_AUTHOR_DATE="$test_tick -0700"
313         export GIT_COMMITTER_DATE GIT_AUTHOR_DATE
314 }
315
316 # Call test_commit with the arguments "<message> [<file> [<contents>]]"
317 #
318 # This will commit a file with the given contents and the given commit
319 # message.  It will also add a tag with <message> as name.
320 #
321 # Both <file> and <contents> default to <message>.
322
323 test_commit () {
324         file=${2:-"$1.t"}
325         echo "${3-$1}" > "$file" &&
326         git add "$file" &&
327         test_tick &&
328         git commit -m "$1" &&
329         git tag "$1"
330 }
331
332 # Call test_merge with the arguments "<message> <commit>", where <commit>
333 # can be a tag pointing to the commit-to-merge.
334
335 test_merge () {
336         test_tick &&
337         git merge -m "$1" "$2" &&
338         git tag "$1"
339 }
340
341 # This function helps systems where core.filemode=false is set.
342 # Use it instead of plain 'chmod +x' to set or unset the executable bit
343 # of a file in the working directory and add it to the index.
344
345 test_chmod () {
346         chmod "$@" &&
347         git update-index --add "--chmod=$@"
348 }
349
350 # Use test_set_prereq to tell that a particular prerequisite is available.
351 # The prerequisite can later be checked for in two ways:
352 #
353 # - Explicitly using test_have_prereq.
354 #
355 # - Implicitly by specifying the prerequisite tag in the calls to
356 #   test_expect_{success,failure,code}.
357 #
358 # The single parameter is the prerequisite tag (a simple word, in all
359 # capital letters by convention).
360
361 test_set_prereq () {
362         satisfied="$satisfied$1 "
363 }
364 satisfied=" "
365
366 test_have_prereq () {
367         # prerequisites can be concatenated with ','
368         save_IFS=$IFS
369         IFS=,
370         set -- $*
371         IFS=$save_IFS
372
373         total_prereq=0
374         ok_prereq=0
375         missing_prereq=
376
377         for prerequisite
378         do
379                 total_prereq=$(($total_prereq + 1))
380                 case $satisfied in
381                 *" $prerequisite "*)
382                         ok_prereq=$(($ok_prereq + 1))
383                         ;;
384                 *)
385                         # Keep a list of missing prerequisites
386                         if test -z "$missing_prereq"
387                         then
388                                 missing_prereq=$prerequisite
389                         else
390                                 missing_prereq="$prerequisite,$missing_prereq"
391                         fi
392                 esac
393         done
394
395         test $total_prereq = $ok_prereq
396 }
397
398 # You are not expected to call test_ok_ and test_failure_ directly, use
399 # the text_expect_* functions instead.
400
401 test_ok_ () {
402         test_success=$(($test_success + 1))
403         say_color "" "ok $test_count - $@"
404 }
405
406 test_failure_ () {
407         test_failure=$(($test_failure + 1))
408         say_color error "not ok - $test_count $1"
409         shift
410         echo "$@" | sed -e 's/^/#       /'
411         test "$immediate" = "" || { GIT_EXIT_OK=t; exit 1; }
412 }
413
414 test_known_broken_ok_ () {
415         test_fixed=$(($test_fixed+1))
416         say_color "" "ok $test_count - $@ # TODO known breakage"
417 }
418
419 test_known_broken_failure_ () {
420         test_broken=$(($test_broken+1))
421         say_color skip "not ok $test_count - $@ # TODO known breakage"
422 }
423
424 test_debug () {
425         test "$debug" = "" || eval "$1"
426 }
427
428 test_run_ () {
429         test_cleanup=:
430         eval >&3 2>&4 "$1"
431         eval_ret=$?
432         eval >&3 2>&4 "$test_cleanup"
433         if test "$verbose" = "t" && test -n "$HARNESS_ACTIVE"; then
434                 echo ""
435         fi
436         return 0
437 }
438
439 test_skip () {
440         test_count=$(($test_count+1))
441         to_skip=
442         for skp in $GIT_SKIP_TESTS
443         do
444                 case $this_test.$test_count in
445                 $skp)
446                         to_skip=t
447                         break
448                 esac
449         done
450         if test -z "$to_skip" && test -n "$prereq" &&
451            ! test_have_prereq "$prereq"
452         then
453                 to_skip=t
454         fi
455         case "$to_skip" in
456         t)
457                 of_prereq=
458                 if test "$missing_prereq" != "$prereq"
459                 then
460                         of_prereq=" of $prereq"
461                 fi
462
463                 say_color skip >&3 "skipping test: $@"
464                 say_color skip "ok $test_count # skip $1 (missing $missing_prereq${of_prereq})"
465                 : true
466                 ;;
467         *)
468                 false
469                 ;;
470         esac
471 }
472
473 test_expect_failure () {
474         test "$#" = 3 && { prereq=$1; shift; } || prereq=
475         test "$#" = 2 ||
476         error "bug in the test script: not 2 or 3 parameters to test-expect-failure"
477         if ! test_skip "$@"
478         then
479                 say >&3 "checking known breakage: $2"
480                 test_run_ "$2"
481                 if [ "$?" = 0 -a "$eval_ret" = 0 ]
482                 then
483                         test_known_broken_ok_ "$1"
484                 else
485                         test_known_broken_failure_ "$1"
486                 fi
487         fi
488         echo >&3 ""
489 }
490
491 test_expect_success () {
492         test "$#" = 3 && { prereq=$1; shift; } || prereq=
493         test "$#" = 2 ||
494         error "bug in the test script: not 2 or 3 parameters to test-expect-success"
495         if ! test_skip "$@"
496         then
497                 say >&3 "expecting success: $2"
498                 test_run_ "$2"
499                 if [ "$?" = 0 -a "$eval_ret" = 0 ]
500                 then
501                         test_ok_ "$1"
502                 else
503                         test_failure_ "$@"
504                 fi
505         fi
506         echo >&3 ""
507 }
508
509 test_expect_code () {
510         test "$#" = 4 && { prereq=$1; shift; } || prereq=
511         test "$#" = 3 ||
512         error "bug in the test script: not 3 or 4 parameters to test-expect-code"
513         if ! test_skip "$@"
514         then
515                 say >&3 "expecting exit code $1: $3"
516                 test_run_ "$3"
517                 if [ "$?" = 0 -a "$eval_ret" = "$1" ]
518                 then
519                         test_ok_ "$2"
520                 else
521                         test_failure_ "$@"
522                 fi
523         fi
524         echo >&3 ""
525 }
526
527 # test_external runs external test scripts that provide continuous
528 # test output about their progress, and succeeds/fails on
529 # zero/non-zero exit code.  It outputs the test output on stdout even
530 # in non-verbose mode, and announces the external script with "# run
531 # <n>: ..." before running it.  When providing relative paths, keep in
532 # mind that all scripts run in "trash directory".
533 # Usage: test_external description command arguments...
534 # Example: test_external 'Perl API' perl ../path/to/test.pl
535 test_external () {
536         test "$#" = 4 && { prereq=$1; shift; } || prereq=
537         test "$#" = 3 ||
538         error >&5 "bug in the test script: not 3 or 4 parameters to test_external"
539         descr="$1"
540         shift
541         if ! test_skip "$descr" "$@"
542         then
543                 # Announce the script to reduce confusion about the
544                 # test output that follows.
545                 say_color "" "# run $test_count: $descr ($*)"
546                 # Export TEST_DIRECTORY, TRASH_DIRECTORY and GIT_TEST_LONG
547                 # to be able to use them in script
548                 export TEST_DIRECTORY TRASH_DIRECTORY GIT_TEST_LONG
549                 # Run command; redirect its stderr to &4 as in
550                 # test_run_, but keep its stdout on our stdout even in
551                 # non-verbose mode.
552                 "$@" 2>&4
553                 if [ "$?" = 0 ]
554                 then
555                         if test $test_external_has_tap -eq 0; then
556                                 test_ok_ "$descr"
557                         else
558                                 say_color "" "# test_external test $descr was ok"
559                                 test_success=$(($test_success + 1))
560                         fi
561                 else
562                         if test $test_external_has_tap -eq 0; then
563                                 test_failure_ "$descr" "$@"
564                         else
565                                 say_color error "# test_external test $descr failed: $@"
566                                 test_failure=$(($test_failure + 1))
567                         fi
568                 fi
569         fi
570 }
571
572 # Like test_external, but in addition tests that the command generated
573 # no output on stderr.
574 test_external_without_stderr () {
575         # The temporary file has no (and must have no) security
576         # implications.
577         tmp="$TMPDIR"; if [ -z "$tmp" ]; then tmp=/tmp; fi
578         stderr="$tmp/git-external-stderr.$$.tmp"
579         test_external "$@" 4> "$stderr"
580         [ -f "$stderr" ] || error "Internal error: $stderr disappeared."
581         descr="no stderr: $1"
582         shift
583         say >&3 "# expecting no stderr from previous command"
584         if [ ! -s "$stderr" ]; then
585                 rm "$stderr"
586
587                 if test $test_external_has_tap -eq 0; then
588                         test_ok_ "$descr"
589                 else
590                         say_color "" "# test_external_without_stderr test $descr was ok"
591                         test_success=$(($test_success + 1))
592                 fi
593         else
594                 if [ "$verbose" = t ]; then
595                         output=`echo; echo "# Stderr is:"; cat "$stderr"`
596                 else
597                         output=
598                 fi
599                 # rm first in case test_failure exits.
600                 rm "$stderr"
601                 if test $test_external_has_tap -eq 0; then
602                         test_failure_ "$descr" "$@" "$output"
603                 else
604                         say_color error "# test_external_without_stderr test $descr failed: $@: $output"
605                         test_failure=$(($test_failure + 1))
606                 fi
607         fi
608 }
609
610 # debugging-friendly alternatives to "test [-f|-d|-e]"
611 # The commands test the existence or non-existence of $1. $2 can be
612 # given to provide a more precise diagnosis.
613 test_path_is_file () {
614         if ! [ -f "$1" ]
615         then
616                 echo "File $1 doesn't exist. $*"
617                 false
618         fi
619 }
620
621 test_path_is_dir () {
622         if ! [ -d "$1" ]
623         then
624                 echo "Directory $1 doesn't exist. $*"
625                 false
626         fi
627 }
628
629 test_path_is_missing () {
630         if [ -e "$1" ]
631         then
632                 echo "Path exists:"
633                 ls -ld "$1"
634                 if [ $# -ge 1 ]; then
635                         echo "$*"
636                 fi
637                 false
638         fi
639 }
640
641
642 # This is not among top-level (test_expect_success | test_expect_failure)
643 # but is a prefix that can be used in the test script, like:
644 #
645 #       test_expect_success 'complain and die' '
646 #           do something &&
647 #           do something else &&
648 #           test_must_fail git checkout ../outerspace
649 #       '
650 #
651 # Writing this as "! git checkout ../outerspace" is wrong, because
652 # the failure could be due to a segv.  We want a controlled failure.
653
654 test_must_fail () {
655         "$@"
656         exit_code=$?
657         if test $exit_code = 0; then
658                 echo >&2 "test_must_fail: command succeeded: $*"
659                 return 1
660         elif test $exit_code -gt 129 -a $exit_code -le 192; then
661                 echo >&2 "test_must_fail: died by signal: $*"
662                 return 1
663         elif test $exit_code = 127; then
664                 echo >&2 "test_must_fail: command not found: $*"
665                 return 1
666         fi
667         return 0
668 }
669
670 # Similar to test_must_fail, but tolerates success, too.  This is
671 # meant to be used in contexts like:
672 #
673 #       test_expect_success 'some command works without configuration' '
674 #               test_might_fail git config --unset all.configuration &&
675 #               do something
676 #       '
677 #
678 # Writing "git config --unset all.configuration || :" would be wrong,
679 # because we want to notice if it fails due to segv.
680
681 test_might_fail () {
682         "$@"
683         exit_code=$?
684         if test $exit_code -gt 129 -a $exit_code -le 192; then
685                 echo >&2 "test_might_fail: died by signal: $*"
686                 return 1
687         elif test $exit_code = 127; then
688                 echo >&2 "test_might_fail: command not found: $*"
689                 return 1
690         fi
691         return 0
692 }
693
694 # test_cmp is a helper function to compare actual and expected output.
695 # You can use it like:
696 #
697 #       test_expect_success 'foo works' '
698 #               echo expected >expected &&
699 #               foo >actual &&
700 #               test_cmp expected actual
701 #       '
702 #
703 # This could be written as either "cmp" or "diff -u", but:
704 # - cmp's output is not nearly as easy to read as diff -u
705 # - not all diff versions understand "-u"
706
707 test_cmp() {
708         $GIT_TEST_CMP "$@"
709 }
710
711 # This function can be used to schedule some commands to be run
712 # unconditionally at the end of the test to restore sanity:
713 #
714 #       test_expect_success 'test core.capslock' '
715 #               git config core.capslock true &&
716 #               test_when_finished "git config --unset core.capslock" &&
717 #               hello world
718 #       '
719 #
720 # That would be roughly equivalent to
721 #
722 #       test_expect_success 'test core.capslock' '
723 #               git config core.capslock true &&
724 #               hello world
725 #               git config --unset core.capslock
726 #       '
727 #
728 # except that the greeting and config --unset must both succeed for
729 # the test to pass.
730
731 test_when_finished () {
732         test_cleanup="{ $*
733                 } && (exit \"\$eval_ret\"); eval_ret=\$?; $test_cleanup"
734 }
735
736 # Most tests can use the created repository, but some may need to create more.
737 # Usage: test_create_repo <directory>
738 test_create_repo () {
739         test "$#" = 1 ||
740         error "bug in the test script: not 1 parameter to test-create-repo"
741         repo="$1"
742         mkdir -p "$repo"
743         (
744                 cd "$repo" || error "Cannot setup test environment"
745                 "$GIT_EXEC_PATH/git-init" "--template=$GIT_BUILD_DIR/templates/blt/" >&3 2>&4 ||
746                 error "cannot run git init -- have you built things yet?"
747                 mv .git/hooks .git/hooks-disabled
748         ) || exit
749 }
750
751 test_done () {
752         GIT_EXIT_OK=t
753
754         if test -z "$HARNESS_ACTIVE"; then
755                 test_results_dir="$TEST_DIRECTORY/test-results"
756                 mkdir -p "$test_results_dir"
757                 test_results_path="$test_results_dir/${0%.sh}-$$.counts"
758
759                 echo "total $test_count" >> $test_results_path
760                 echo "success $test_success" >> $test_results_path
761                 echo "fixed $test_fixed" >> $test_results_path
762                 echo "broken $test_broken" >> $test_results_path
763                 echo "failed $test_failure" >> $test_results_path
764                 echo "" >> $test_results_path
765         fi
766
767         if test "$test_fixed" != 0
768         then
769                 say_color pass "# fixed $test_fixed known breakage(s)"
770         fi
771         if test "$test_broken" != 0
772         then
773                 say_color error "# still have $test_broken known breakage(s)"
774                 msg="remaining $(($test_count-$test_broken)) test(s)"
775         else
776                 msg="$test_count test(s)"
777         fi
778         case "$test_failure" in
779         0)
780                 # Maybe print SKIP message
781                 [ -z "$skip_all" ] || skip_all=" # SKIP $skip_all"
782
783                 if test $test_external_has_tap -eq 0; then
784                         say_color pass "# passed all $msg"
785                         say "1..$test_count$skip_all"
786                 fi
787
788                 test -d "$remove_trash" &&
789                 cd "$(dirname "$remove_trash")" &&
790                 rm -rf "$(basename "$remove_trash")"
791
792                 exit 0 ;;
793
794         *)
795                 if test $test_external_has_tap -eq 0; then
796                         say_color error "# failed $test_failure among $msg"
797                         say "1..$test_count"
798                 fi
799
800                 exit 1 ;;
801
802         esac
803 }
804
805 # Test the binaries we have just built.  The tests are kept in
806 # t/ subdirectory and are run in 'trash directory' subdirectory.
807 if test -z "$TEST_DIRECTORY"
808 then
809         # We allow tests to override this, in case they want to run tests
810         # outside of t/, e.g. for running tests on the test library
811         # itself.
812         TEST_DIRECTORY=$(pwd)
813 fi
814 GIT_BUILD_DIR="$TEST_DIRECTORY"/..
815
816 if test -n "$valgrind"
817 then
818         make_symlink () {
819                 test -h "$2" &&
820                 test "$1" = "$(readlink "$2")" || {
821                         # be super paranoid
822                         if mkdir "$2".lock
823                         then
824                                 rm -f "$2" &&
825                                 ln -s "$1" "$2" &&
826                                 rm -r "$2".lock
827                         else
828                                 while test -d "$2".lock
829                                 do
830                                         say "Waiting for lock on $2."
831                                         sleep 1
832                                 done
833                         fi
834                 }
835         }
836
837         make_valgrind_symlink () {
838                 # handle only executables
839                 test -x "$1" || return
840
841                 base=$(basename "$1")
842                 symlink_target=$GIT_BUILD_DIR/$base
843                 # do not override scripts
844                 if test -x "$symlink_target" &&
845                     test ! -d "$symlink_target" &&
846                     test "#!" != "$(head -c 2 < "$symlink_target")"
847                 then
848                         symlink_target=../valgrind.sh
849                 fi
850                 case "$base" in
851                 *.sh|*.perl)
852                         symlink_target=../unprocessed-script
853                 esac
854                 # create the link, or replace it if it is out of date
855                 make_symlink "$symlink_target" "$GIT_VALGRIND/bin/$base" || exit
856         }
857
858         # override all git executables in TEST_DIRECTORY/..
859         GIT_VALGRIND=$TEST_DIRECTORY/valgrind
860         mkdir -p "$GIT_VALGRIND"/bin
861         for file in $GIT_BUILD_DIR/git* $GIT_BUILD_DIR/test-*
862         do
863                 make_valgrind_symlink $file
864         done
865         OLDIFS=$IFS
866         IFS=:
867         for path in $PATH
868         do
869                 ls "$path"/git-* 2> /dev/null |
870                 while read file
871                 do
872                         make_valgrind_symlink "$file"
873                 done
874         done
875         IFS=$OLDIFS
876         PATH=$GIT_VALGRIND/bin:$PATH
877         GIT_EXEC_PATH=$GIT_VALGRIND/bin
878         export GIT_VALGRIND
879 elif test -n "$GIT_TEST_INSTALLED" ; then
880         GIT_EXEC_PATH=$($GIT_TEST_INSTALLED/git --exec-path)  ||
881         error "Cannot run git from $GIT_TEST_INSTALLED."
882         PATH=$GIT_TEST_INSTALLED:$GIT_BUILD_DIR:$PATH
883         GIT_EXEC_PATH=${GIT_TEST_EXEC_PATH:-$GIT_EXEC_PATH}
884 else # normal case, use ../bin-wrappers only unless $with_dashes:
885         git_bin_dir="$GIT_BUILD_DIR/bin-wrappers"
886         if ! test -x "$git_bin_dir/git" ; then
887                 if test -z "$with_dashes" ; then
888                         say "$git_bin_dir/git is not executable; using GIT_EXEC_PATH"
889                 fi
890                 with_dashes=t
891         fi
892         PATH="$git_bin_dir:$PATH"
893         GIT_EXEC_PATH=$GIT_BUILD_DIR
894         if test -n "$with_dashes" ; then
895                 PATH="$GIT_BUILD_DIR:$PATH"
896         fi
897 fi
898 GIT_TEMPLATE_DIR="$GIT_BUILD_DIR"/templates/blt
899 unset GIT_CONFIG
900 GIT_CONFIG_NOSYSTEM=1
901 GIT_CONFIG_NOGLOBAL=1
902 export PATH GIT_EXEC_PATH GIT_TEMPLATE_DIR GIT_CONFIG_NOSYSTEM GIT_CONFIG_NOGLOBAL
903
904 . "$GIT_BUILD_DIR"/GIT-BUILD-OPTIONS
905
906 if test -z "$GIT_TEST_CMP"
907 then
908         if test -n "$GIT_TEST_CMP_USE_COPIED_CONTEXT"
909         then
910                 GIT_TEST_CMP="$DIFF -c"
911         else
912                 GIT_TEST_CMP="$DIFF -u"
913         fi
914 fi
915
916 GITPERLLIB="$GIT_BUILD_DIR"/perl/blib/lib:"$GIT_BUILD_DIR"/perl/blib/arch/auto/Git
917 export GITPERLLIB
918 test -d "$GIT_BUILD_DIR"/templates/blt || {
919         error "You haven't built things yet, have you?"
920 }
921
922 if test -z "$GIT_TEST_INSTALLED" && test -z "$NO_PYTHON"
923 then
924         GITPYTHONLIB="$GIT_BUILD_DIR/git_remote_helpers/build/lib"
925         export GITPYTHONLIB
926         test -d "$GIT_BUILD_DIR"/git_remote_helpers/build || {
927                 error "You haven't built git_remote_helpers yet, have you?"
928         }
929 fi
930
931 if ! test -x "$GIT_BUILD_DIR"/test-chmtime; then
932         echo >&2 'You need to build test-chmtime:'
933         echo >&2 'Run "make test-chmtime" in the source (toplevel) directory'
934         exit 1
935 fi
936
937 # Test repository
938 test="trash directory.$(basename "$0" .sh)"
939 test -n "$root" && test="$root/$test"
940 case "$test" in
941 /*) TRASH_DIRECTORY="$test" ;;
942  *) TRASH_DIRECTORY="$TEST_DIRECTORY/$test" ;;
943 esac
944 test ! -z "$debug" || remove_trash=$TRASH_DIRECTORY
945 rm -fr "$test" || {
946         GIT_EXIT_OK=t
947         echo >&5 "FATAL: Cannot prepare test area"
948         exit 1
949 }
950
951 test_create_repo "$test"
952 # Use -P to resolve symlinks in our working directory so that the cwd
953 # in subprocesses like git equals our $PWD (for pathname comparisons).
954 cd -P "$test" || exit 1
955
956 HOME=$(pwd)
957 export HOME
958
959 this_test=${0##*/}
960 this_test=${this_test%%-*}
961 for skp in $GIT_SKIP_TESTS
962 do
963         case "$this_test" in
964         $skp)
965                 say_color skip >&3 "skipping test $this_test altogether"
966                 skip_all="skip all tests in $this_test"
967                 test_done
968         esac
969 done
970
971 # Provide an implementation of the 'yes' utility
972 yes () {
973         if test $# = 0
974         then
975                 y=y
976         else
977                 y="$*"
978         fi
979
980         while echo "$y"
981         do
982                 :
983         done
984 }
985
986 # Fix some commands on Windows
987 case $(uname -s) in
988 *MINGW*)
989         # Windows has its own (incompatible) sort and find
990         sort () {
991                 /usr/bin/sort "$@"
992         }
993         find () {
994                 /usr/bin/find "$@"
995         }
996         sum () {
997                 md5sum "$@"
998         }
999         # git sees Windows-style pwd
1000         pwd () {
1001                 builtin pwd -W
1002         }
1003         # no POSIX permissions
1004         # backslashes in pathspec are converted to '/'
1005         # exec does not inherit the PID
1006         ;;
1007 *)
1008         test_set_prereq POSIXPERM
1009         test_set_prereq BSLASHPSPEC
1010         test_set_prereq EXECKEEPSPID
1011         ;;
1012 esac
1013
1014 test -z "$NO_PERL" && test_set_prereq PERL
1015 test -z "$NO_PYTHON" && test_set_prereq PYTHON
1016
1017 # test whether the filesystem supports symbolic links
1018 ln -s x y 2>/dev/null && test -h y 2>/dev/null && test_set_prereq SYMLINKS
1019 rm -f y
1020
1021 # When the tests are run as root, permission tests will report that
1022 # things are writable when they shouldn't be.
1023 test -w / || test_set_prereq SANITY